/*********************************************************************
 *
 * Class   : EIBGroupObject.java
 *
 * Author  : Georg Walkner
 *
 * Purpose : Encapsulates an EIB-Group Object
 *           Adress / Type / Data
 *
 * Date    : 05-Mar-2002
 *
 ********************************************************************/
package EIB; 

import java.io.*;

import com.eiblet.bus.*;
import com.eiblet.bus.eib.*; 

public class EIBGroupObject 
{
    
    EIBGroupAddress fEIBGroupAddress = null;
    EISType fEISType = null;
    byte[] fDataByteArray = {0};
    EIBLowLevelGroupObjectBusCommunicator fEIBLowLevelGroupObjectBusCommunicator = null;
    
    public EIBGroupObject(EIBGroupAddress pEIBGroupAddress, 
			  EISType pEISType, 
			  EIBLowLevelGroupObjectBusCommunicator pEIBLowLevelGroupObjectBusCommunicator)
    {
	fEIBGroupAddress = pEIBGroupAddress;
	fEISType = pEISType;
	fEIBLowLevelGroupObjectBusCommunicator = pEIBLowLevelGroupObjectBusCommunicator;
    }

    public EIBGroupAddress getEIBGroupAddress(){
	return fEIBGroupAddress; 
    }
    
    public void setData(byte[] pData){
	fDataByteArray = pData;
    }
 
    public byte[] getData(){
	return fDataByteArray;
    }
 
    public void writeGroupData(byte[] pData) throws IOException, IllegalArgumentException{
	fEIBLowLevelGroupObjectBusCommunicator.writeGroupData(fEIBGroupAddress,3 ,6 ,true, pData);
    }		
}
