package tutorial; 


import java.awt.event.*;
import java.awt.*; 
//import javax.swing.*;
import java.io.*; import com.eiblet.*;
import com.eiblet.bus.*;
import com.eiblet.bus.eib.*; 

public class EIB_AWT extends Frame
	implements EIBLowLevelGroupObjectBusCommunicatorEventListener 
{
   
    private MyButtonAWT fButton1 = null;
    private MyButtonAWT fButton2 = null;
    private MyButtonAWT fButton3 = null;
    private MyButtonAWT fButton4 = null;
    private Button fButtonBus = null;
    private MyCheckBox fMyCheckBox = null;
    
    private EIBLowLevelGroupObjectBusCommunicator fEIBLowLevelGroupObjectBusCommunicator = null;
    
    public EIB_AWT(EIBLowLevelGroupObjectBusCommunicator pEIBLowLevelGroupObjectBusCommunicator)
    {
	super("Example for the tutorial EIB Java");
	fEIBLowLevelGroupObjectBusCommunicator = pEIBLowLevelGroupObjectBusCommunicator;
	fEIBLowLevelGroupObjectBusCommunicator.setEIBLowLevelGroupObjectBusCommunicatorEventListener(this);
		
	// Panel pane = new Panel();
	fButton1 = new MyButtonAWT("GA 1.1.1",
				   new EIBGroupAddress(1,1,1),
				   new EISType(EISType.EIS_TYPE_SWITCH),
				   pEIBLowLevelGroupObjectBusCommunicator);
	fButton2 = new MyButtonAWT("GA 1.1.2",
				   new EIBGroupAddress(1,1,2),
				   new EISType(EISType.EIS_TYPE_SWITCH),
				   pEIBLowLevelGroupObjectBusCommunicator);
	fButton3 = new MyButtonAWT("GA 1.1.3",new EIBGroupAddress(1,1,3),
				   new EISType(EISType.EIS_TYPE_SWITCH),
				   pEIBLowLevelGroupObjectBusCommunicator);
	fButton4 = new MyButtonAWT("GA 1.1.4",new EIBGroupAddress(1,1,4),
				   new EISType(EISType.EIS_TYPE_SWITCH),
				   pEIBLowLevelGroupObjectBusCommunicator);
	fButtonBus = new Button("BusConnect");
	fButtonBus.addMouseListener(new Bus_MouseListener());
	
	this.add(fButton1);
	this.add(fButton2);
	this.add(fButton3);  
	this.add(fButton4);
	
	fMyCheckBox = new MyCheckBox("state connection", fEIBLowLevelGroupObjectBusCommunicator);
	if(fEIBLowLevelGroupObjectBusCommunicator.isConnected()){
	    fMyCheckBox.setState(true);
	}
	fMyCheckBox.setEnabled(true);
	this.add(fMyCheckBox);
	this.add(fButtonBus);
	this.setLayout(new FlowLayout());
	
	this.addWindowListener(new TheWindowListener(pEIBLowLevelGroupObjectBusCommunicator));
	this.pack();
	this.setSize(200,200);
	this.setVisible(true);
    } // constructor from the class
    
    
    
    public void handleEIBLowLevelGroupObjectBusCommunicatorEvent
	(EIBLowLevelGroupObjectBusCommunicatorEvent pEvent)
    {
	fButton1.handleEvent(pEvent);
	fButton2.handleEvent(pEvent);
	fButton3.handleEvent(pEvent);
	fButton4.handleEvent(pEvent);
    }
    
    class Bus_MouseListener extends MouseAdapter
    {
	public void mouseClicked(MouseEvent event)
	{
	    if(fEIBLowLevelGroupObjectBusCommunicator.isConnected()){
		fEIBLowLevelGroupObjectBusCommunicator.close();
	    }
	    else{
		fEIBLowLevelGroupObjectBusCommunicator.open();
	    }
	}
    }//end class Bus_MouseListener
    
    
    class MyCheckBox extends Checkbox 
	implements BusCommunicatorStatusEventListener
    {
	public MyCheckBox(String pName, 
			  EIBLowLevelGroupObjectBusCommunicator fEIBLowLevelGroupObjectBusCommunicator)
	{
	    super(pName); 
	    fEIBLowLevelGroupObjectBusCommunicator.addBusCommunicatorStatusEventListener(this);
	}
	
	public void handleBusCommunicatorStatusEvent(BusCommunicatorStatusEvent pEvent)
	{
	    System.out.println("Bus Event" + pEvent);
	    System.out.println("connect" + fEIBLowLevelGroupObjectBusCommunicator.isConnected());
	    
	    if(fEIBLowLevelGroupObjectBusCommunicator.isConnected()){
		this.setState(true); 
	    }
	    else{
		this.setState(false);    
	    }
	}
    }//end class My_MouseListener   
    
    class TheWindowListener extends WindowAdapter
    {
	private EIBLowLevelGroupObjectBusCommunicator fEIBLowLevelGroupObjectBusCommunicator = null;
	
	public TheWindowListener(EIBLowLevelGroupObjectBusCommunicator pEIBLowLevelGroupObjectBusCommunicator)
	{
	    fEIBLowLevelGroupObjectBusCommunicator = pEIBLowLevelGroupObjectBusCommunicator;
	}
	
	public void windowClosing(WindowEvent e)
	{
	    fEIBLowLevelGroupObjectBusCommunicator.close();
	    System.exit(0);
	}
    } 
} // end of class
