package tutorial; 

import java.io.*;

import com.eiblet.*;
import com.eiblet.bus.*;
import com.eiblet.bus.eib.*; import java.awt.event.*;
import java.awt.*; 

public class MyButtonAWT extends Button 
    implements  BusCommunicatorStatusEventListener
{
 
    private EIBLowLevelGroupObjectBusCommunicator fEIBLowLevelGroupObjectBusCommunicator = null;
    public GroupObjectAWT fGroupObject = null;
    public static final byte[] pEin = {1};
    public static final byte[] pAus = {0};
    
    public MyButtonAWT(String pButtonName, 
		       EIBGroupAddress pEIBGroupAddress, 
		       EISType pEISType, 
		       EIBLowLevelGroupObjectBusCommunicator pEIBLowLevelGroupObjectBusCommunicator)
    {
	super(pButtonName);
	fEIBLowLevelGroupObjectBusCommunicator = pEIBLowLevelGroupObjectBusCommunicator;
	fEIBLowLevelGroupObjectBusCommunicator.addBusCommunicatorStatusEventListener(this);
	fGroupObject = new GroupObjectAWT(pEIBGroupAddress, pEISType, pEIBLowLevelGroupObjectBusCommunicator);
	this.addMouseListener(new My_MouseListener());
    }
    
    
    public void handleEvent(EIBLowLevelGroupObjectBusCommunicatorEvent pEvent){
	if((fGroupObject.getEIBGroupAddress()).equals(pEvent.getEIBGroupAddress())){
	    fGroupObject.setData(pEvent.getData());
	    if((fGroupObject.getData())[0] == pEin[0]){
		this.setBackground(Color.green);
	    }
	    else{
		this.setBackground(Color.red);
	    }
	}
    }
    
    public void handleBusCommunicatorStatusEvent(BusCommunicatorStatusEvent pEvent){
	if(BusCommunicatorStatusEvent.STATUS_DISCONNECTED == pEvent.getStatus()){
	    this.setBackground(Color.lightGray);
	}
    }   

    class My_MouseListener extends MouseAdapter
    {
	public void mouseClicked(MouseEvent event){
	    if(((fGroupObject.getData())[0] == pAus[0])) {
		try{
		    fGroupObject.writeGroupData(pEin);
		}
		catch(IOException e){
		    System.out.println(e.getMessage());
		}
	    }
	    else{
		try{
		    fGroupObject.writeGroupData(pAus);
		}
		catch(IOException e){
		    System.out.println(e.getMessage());
		}
	    }
	}
    }//end class My_MouseListener 
}
